/**
 * Architektur & Implementierung von DBMS, Aufgabenblatt 7
 *
 * Bitmap Indexing, Query Processing and WAH Compression
 *
 * File        : queries.h
 */

#ifndef QUERIES_H
#define QUERIES_H

#include <stdint.h>

#include "schema.h"
#include "BitmapIndex.h"

int32_t
query1(uint32_t numrows, lineitem_t  *inputtable);

int32_t
query1_with_index(uint32_t numrows, lineitem_t  *inputtable, 
                  BitmapIndex<int32_t> & bitmap_idx_linenumber);

int32_t
query2(uint32_t numrows, lineitem_t  *inputtable);

int32_t
query2_with_index(uint32_t numrows, lineitem_t  *inputtable,
                  BitmapIndex<int32_t> & bitmap_idx_linenumber,
                  BitmapIndex<char[11]> & bitmap_idx_shipmode,
                  BitmapIndex<int64_t> & bitmap_idx_quantity);

int32_t
query3(uint32_t numrows, lineitem_t  *inputtable);

int32_t
query3_with_index(uint32_t numrows, lineitem_t  *inputtable,
                  BitmapIndex<int32_t> & bitmap_idx_linenumber,
                  BitmapIndex<char[11]> & bitmap_idx_shipmode);


double
query4(uint32_t numrows, lineitem_t  *inputtable);

double
query4_with_index(uint32_t numrows, lineitem_t  *inputtable,
                  BitmapIndex<char> & bitmap_idx_returnflag,
                  BitmapIndex<char[11]> & bitmap_idx_shipmode,
                  BitmapIndex<int64_t> & bitmap_idx_quantity);

#endif /* QUERIES_H */
